# This file is subject to the terms and conditions defined in
# file 'LICENSE.txt', which is part of this source code package.
module Arguard
  module Guards
    module ObjectsGuard
      def not_nil!(object_name = nil)
        if self.nil?
          exc_message = object_name.nil? ? "Object must not be nil. Class: '#{self.class.name}'" : "Object must not be nil. Class: '#{self.class.name}', Name: '#{object_name}'"

          raise ArgumentError.new(exc_message)
        end
        self
      end

      def true!(message = nil)
        unless self.class == TrueClass
          exc_message = message.nil? ? 'Condition must be true.' : "Condition must be true. Message: '#{message}'"

          raise ArgumentError.new(exc_message)
        end
        self
      end

      def false!(message = nil)
        unless self.class == FalseClass
          exc_message = message.nil? ? 'Condition must be false.' : "Condition must be false. Message: '#{message}'"

          raise ArgumentError.new(exc_message)
        end
        self
      end
    end
  end
end